import { getIterator, isAsyncIterable } from './utils/iterator.js';
export function sort(comparator) {
    return function sortFn(data) {
        if (isAsyncIterable(data) || data instanceof Promise) {
            return {
                async *[Symbol.asyncIterator]() {
                    let stream = data instanceof Promise ? await data : data;
                    let result = [];
                    // @ts-expect-error I'm probably doing something stupid here...
                    for await (let datum of getIterator(stream))
                        result.push(datum);
                    yield* result.sort(comparator);
                },
            };
        }
        return {
            *[Symbol.iterator]() {
                for (let datum of Array.from(data).sort(comparator)) {
                    yield datum;
                }
            },
        };
    };
}
