export function isIterable(input) {
    if (typeof input !== 'object' || input === null)
        return false;
    return input[Symbol.iterator] !== undefined;
}
export function isAsyncIterable(input) {
    if (typeof input !== 'object' || input === null)
        return false;
    return input[Symbol.asyncIterator] !== undefined;
}
export function getIterator(input) {
    if (isAsyncIterable(input)) {
        return input[Symbol.asyncIterator]();
    }
    if (isIterable(input)) {
        return input[Symbol.iterator]();
    }
    throw new Error('`input` is not an iterable');
}
